# Section 1. What is C#?

## The history of C#

**Microsoft C#**
* Orignal name: "C-like Object Oriented Language"
* Announsed at July 2000 Microsoft Professional Developers Conference along with the .NET Framework
* Mono is the open-source competitor to C#

**C#'s Original Specification Document**
* Intended to be a simple, modern, general-purpose, object-oriented language
* Support software engineering principles:
  * strong type checking
  * array bounds checking
  * detection of attempts to use uninitialized variables
  * auto garbage collection
* Suitable for deployment in distributed environments
* High portability (Software can be compiled and linked from source code for different operating systems and processors)
* Suitable for writing applications for both **hosted** (large OS) and **embedded** systems (small functions)
* C# has low memory and processing power consumption, but not good as C or assembly

## C#, the .NET Framework and runtime

**.NET Framework**
* a software framework